#--
# Credit goes to bitsweat and Rails.
#++

class Module

  # Encapsulates the common pattern of:
  #
  #   alias_method :foo_without_feature, :foo
  #   alias_method :foo, :foo_with_feature
  #
  # With this, you simply do:
  #
  #   alias_method_chain :foo, :feature
  #
  # And both aliases are set up for you.
  #
  # Query and bang methods (foo?, foo!) keep the same punctuation:
  #
  #   alias_method_chain :foo?, :feature
  #
  # is equivalent to
  #
  #   alias_method :foo_without_feature?, :foo?
  #   alias_method :foo?, :foo_without_feature?
  #
  # so you can safely chain foo, foo?, and foo! with the same feature.

  def alias_method_chain(target, feature)
    # Strip out punctuation on predicates or bang methods since
    # e.g. target?_without_feature is not a valid method name.
    aliased_target, punctuation = target.to_s.sub(/([?!])$/, ''), $1
    alias_method "#{aliased_target}_without_#{feature}#{punctuation}", target
    alias_method target, "#{aliased_target}_with_#{feature}#{punctuation}"
  end

end


=begin test

  require 'test/unit'

  class TestAliasChain < Test::Unit::TestCase

    module X
      def self.included(base)
        base.module_eval {
          alias_method_chain :foo, :feature
        }
      end
      def foo_with_feature
        foo_without_feature + '!'
      end
    end

    class Y
      def foo
        "FOO"
      end
      include X
      #alias_method_chain :foo, :feature
    end

    def test_001
      y = Y.new
      assert_equal( "FOO!", y.foo )
    end

  end

=end
